#pragma once
/* this file was auto-generated from ./src/modules/flow/gtk/gtk.json */
#include <stdbool.h>
#include <stdint.h>
#include <sol-flow.h>


#ifdef __cplusplus
extern "C" {
#endif

#define SOL_FLOW_NODE_TYPE_GTK_BYTE_EDITOR_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_BYTE_EDITOR;

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_BYTE_EDITOR__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_BYTE_EDITOR__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_LABEL_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_LABEL;

/* Input Ports */
#define SOL_FLOW_NODE_TYPE_GTK_LABEL__IN__IN (0)
#define SOL_FLOW_NODE_TYPE_GTK_LABEL__IN_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_LED_7SEG_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_LED_7SEG;

struct sol_flow_node_type_gtk_led_7seg_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_GTK_LED_7SEG_OPTIONS_API_VERSION (1)
    bool common_cathode; /**< Set this option to true if type of led is common cathode or set it to false if it's common anode (it'll invert gpio low and high states). It's a dummy option used for compatibility with 'led-7seg/led'. (default: True) */
    int32_t pin_a; /**< Pin used to set segment 'A' state. It's a dummy option used for compatibility with 'led-7seg/led'. (default: 0) */
    int32_t pin_b; /**< Pin used to set segment 'B' state. It's a dummy option used for compatibility with 'led-7seg/led'. (default: 0) */
    int32_t pin_c; /**< Pin used to set segment 'C' state. It's a dummy option used for compatibility with 'led-7seg/led'. (default: 0) */
    int32_t pin_d; /**< Pin used to set segment 'D' state. It's a dummy option used for compatibility with 'led-7seg/led'. (default: 0) */
    int32_t pin_e; /**< Pin used to set segment 'E' state. It's a dummy option used for compatibility with 'led-7seg/led'. (default: 0) */
    int32_t pin_f; /**< Pin used to set segment 'F' state. It's a dummy option used for compatibility with 'led-7seg/led'. (default: 0) */
    int32_t pin_g; /**< Pin used to set segment 'G' state. It's a dummy option used for compatibility with 'led-7seg/led'. (default: 0) */
    int32_t pin_dp; /**< Pin used to set segment 'DP' state. It's a dummy option used for compatibility with 'led-7seg/led'. (default: 0) */
};

#define SOL_FLOW_NODE_TYPE_GTK_LED_7SEG_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_LED_7SEG_OPTIONS_API_VERSION) \
    }, \
    .common_cathode = true, \
    .pin_a = 0, \
    .pin_b = 0, \
    .pin_c = 0, \
    .pin_d = 0, \
    .pin_e = 0, \
    .pin_f = 0, \
    .pin_g = 0, \
    .pin_dp = 0, \
    __VA_ARGS__ \
}
/* Input Ports */
#define SOL_FLOW_NODE_TYPE_GTK_LED_7SEG__IN__VALUE (0)
#define SOL_FLOW_NODE_TYPE_GTK_LED_7SEG__IN__SEGMENTS (1)
#define SOL_FLOW_NODE_TYPE_GTK_LED_7SEG__IN_LAST (1)

#define SOL_FLOW_NODE_TYPE_GTK_LED_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_LED;

struct sol_flow_node_type_gtk_led_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_GTK_LED_OPTIONS_API_VERSION (1)
    struct sol_rgb rgb; /**< The led's RGB color components (default: {'blue': 0, 'green': 0, 'red': 0}) */
    int32_t pin; /**< Pin number. It's a dummy option used for compatibility with 'gpio/writer'. (default: 0) */
};

#define SOL_FLOW_NODE_TYPE_GTK_LED_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_LED_OPTIONS_API_VERSION) \
    }, \
    .rgb = {.blue=0, .blue_max=255, .green=0, .green_max=255, .red=0, .red_max=255}, \
    .pin = 0, \
    __VA_ARGS__ \
}
/* Input Ports */
#define SOL_FLOW_NODE_TYPE_GTK_LED__IN__IN (0)
#define SOL_FLOW_NODE_TYPE_GTK_LED__IN_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON;

struct sol_flow_node_type_gtk_pushbutton_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON_OPTIONS_API_VERSION (1)
    int32_t pin; /**< Pin number. It's a dummy option used for compatibility with 'gpio/reader'. (default: 0) */
};

#define SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON_OPTIONS_API_VERSION) \
    }, \
    .pin = 0, \
    __VA_ARGS__ \
}
/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON__OUT__PRESSED (1)
#define SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON__OUT__RELEASED (2)
#define SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON__OUT_LAST (2)

#define SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR;

struct sol_flow_node_type_gtk_pwm_editor_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR_OPTIONS_API_VERSION (1)
    struct sol_irange_spec range; /**< PWM editor range (default: {'min': 0, 'max': 100}) */
};

#define SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR_OPTIONS_API_VERSION) \
    }, \
    .range = {.max=100, .min=0, .step=1}, \
    __VA_ARGS__ \
}
/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR__OUT__ENABLED (0)
#define SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR__OUT__DUTY_CYCLE (1)
#define SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR__OUT__PERIOD (2)
#define SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR__OUT_LAST (2)

#define SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER;

struct sol_flow_node_type_gtk_pwm_viewer_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER_OPTIONS_API_VERSION (1)
    int32_t chip; /**< PWM chip. It's a dummy option used for compatibility with 'pwm'. (default: 0) */
    int32_t pin; /**< PWM pin channel. It's a dummy option used for compatibility with 'pwm'. (default: 0) */
    bool inversed_polarity; /**< PWM polarity (normal or inversed). It's a dummy option used for compatibility with 'pwm'. (default: False) */
    bool enabled; /**< Initial enabled state (default: False) */
    int32_t period; /**< Initial period (default: 0) */
    int32_t duty_cycle; /**< Initial duty cycle (default: 0) */
};

#define SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER_OPTIONS_API_VERSION) \
    }, \
    .chip = 0, \
    .pin = 0, \
    .inversed_polarity = false, \
    .enabled = false, \
    .period = 0, \
    .duty_cycle = 0, \
    __VA_ARGS__ \
}
/* Input Ports */
#define SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER__IN__ENABLED (0)
#define SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER__IN__DUTY_CYCLE (1)
#define SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER__IN__PERIOD (2)
#define SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER__IN_LAST (2)

#define SOL_FLOW_NODE_TYPE_GTK_RGB_EDITOR_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_RGB_EDITOR;

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_RGB_EDITOR__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_RGB_EDITOR__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_DIRECTION_VECTOR_EDITOR_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_DIRECTION_VECTOR_EDITOR;

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_DIRECTION_VECTOR_EDITOR__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_DIRECTION_VECTOR_EDITOR__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_LOCATION_EDITOR_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_LOCATION_EDITOR;

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_LOCATION_EDITOR__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_LOCATION_EDITOR__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_TIMESTAMP_EDITOR_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_TIMESTAMP_EDITOR;

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_TIMESTAMP_EDITOR__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_TIMESTAMP_EDITOR__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_FLOAT_EDITOR_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_FLOAT_EDITOR;

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_FLOAT_EDITOR__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_FLOAT_EDITOR__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_SLIDER_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_SLIDER;

struct sol_flow_node_type_gtk_slider_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_GTK_SLIDER_OPTIONS_API_VERSION (1)
    struct sol_irange_spec range; /**< Slider's range (default: {'min': 0, 'max': 100}) */
    int32_t device; /**< Device number on platform. It's a dummy option used for compatibility with 'aio/reader'. (default: 0) */
    int32_t pin; /**< Pin number. It's a dummy option used for compatibility with 'aio/reader'. (default: 0) */
};

#define SOL_FLOW_NODE_TYPE_GTK_SLIDER_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_SLIDER_OPTIONS_API_VERSION) \
    }, \
    .range = {.max=100, .min=0, .step=1}, \
    .device = 0, \
    .pin = 0, \
    __VA_ARGS__ \
}
/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_SLIDER__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_SLIDER__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON;

struct sol_flow_node_type_gtk_spinbutton_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON_OPTIONS_API_VERSION (1)
    struct sol_irange_spec range; /**< Spinbutton's range (min / max / step). (default: {'step': 1, 'min': 'INT32_MIN', 'max': 'INT32_MAX'}) */
    int32_t value; /**< Spinbutton's initial value. (default: 0) */
    int32_t device; /**< Device number on platform. It's a dummy option used for compatibility with 'aio/reader'. (default: 0) */
    int32_t pin; /**< Pin number. It's a dummy option used for compatibility with 'aio/reader'. (default: 0) */
};

#define SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON_OPTIONS_API_VERSION) \
    }, \
    .range = {.max=INT32_MAX, .min=INT32_MIN, .step=1}, \
    .value = 0, \
    .device = 0, \
    .pin = 0, \
    __VA_ARGS__ \
}
/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_GTK_TOGGLE_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_TOGGLE;

struct sol_flow_node_type_gtk_toggle_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_GTK_TOGGLE_OPTIONS_API_VERSION (1)
    int32_t pin; /**< Pin number. It's a dummy option used for compatibility with 'gpio/reader'. (default: 0) */
};

#define SOL_FLOW_NODE_TYPE_GTK_TOGGLE_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_TOGGLE_OPTIONS_API_VERSION) \
    }, \
    .pin = 0, \
    __VA_ARGS__ \
}
/* Output Ports */
#define SOL_FLOW_NODE_TYPE_GTK_TOGGLE__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_GTK_TOGGLE__OUT_LAST (0)

#ifndef SOL_LOG_DOMAIN
#define SOL_LOG_DOMAIN &_log_domain
#include "sol-log.h"

#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_DECLARE(_var, _name)     SOL_ATTR_UNUSED struct sol_log_domain _var = {         .name = "sol-" _name,         .color = SOL_LOG_COLOR_MAGENTA,         .level = SOL_LOG_LEVEL_WARNING     }

#define SOL_LOG_INTERNAL_DECLARE_STATIC(_var, _name)     static SOL_LOG_INTERNAL_DECLARE(_var, _name)

SOL_LOG_INTERNAL_DECLARE_STATIC(_log_domain, "flow-gtk");

#else // #ifdef SOL_LOG_ENABLED

#define SOL_LOG_INTERNAL_DECLARE(_var, _name)
#define SOL_LOG_INTERNAL_DECLARE_STATIC(_var, _name)

#ifdef SOL_LOG_DOMAIN
#undef SOL_LOG_DOMAIN
#define SOL_LOG_DOMAIN NULL
#endif // #ifdef SOL_LOG_DOMAIN

#endif // #ifdef SOL_LOG_ENABLED
#endif // ifndef SOL_LOG_DOMAIN

#ifdef __cplusplus
}
#endif
