#pragma once
/* this file was auto-generated from ./src/modules/flow/thingspeak/thingspeak.json */
#include <stdbool.h>
#include <stdint.h>
#include <sol-flow.h>


#ifdef __cplusplus
extern "C" {
#endif

#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE;

struct sol_flow_node_type_thingspeak_talkback_execute_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE_OPTIONS_API_VERSION (1)
    const char * api_key; /**< Thingpeak API key (required) */
    const char * talkback_id; /**< Talkback ID (required) */
    const char * endpoint; /**< Thingspeak endpoint. Defaults to public server (default: 'https://api.thingspeak.com/') */
    int32_t interval; /**< Poll interval in milliseconds. Default to one request every 1000ms. (default: 1000) */
};

#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE_OPTIONS_API_VERSION) \
    }, \
    .endpoint = "https://api.thingspeak.com/", \
    .interval = 1000, \
    __VA_ARGS__ \
}
/* Output Ports */
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE__OUT__OUT (0)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE__OUT_LAST (0)

#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD;

struct sol_flow_node_type_thingspeak_talkback_add_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD_OPTIONS_API_VERSION (1)
    const char * api_key; /**< Thingpeak API key (required) */
    const char * talkback_id; /**< Talkback ID (required) */
    const char * endpoint; /**< Thingspeak endpoint. Defaults to public server (default: 'https://api.thingspeak.com/') */
    int32_t position; /**< Position for this command to appear in the queue. Default is end of queue (default: -1) */
};

#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD_OPTIONS_API_VERSION) \
    }, \
    .endpoint = "https://api.thingspeak.com/", \
    .position = -1, \
    __VA_ARGS__ \
}
/* Input Ports */
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD__IN__IN (0)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD__IN_LAST (0)

#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE;

struct sol_flow_node_type_thingspeak_channel_update_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE_OPTIONS_API_VERSION (1)
    const char * api_key; /**< Thingpeak API key (required) */
    const char * endpoint; /**< Thingspeak endpoint. Defaults to public server (default: 'https://api.thingspeak.com/') */
};

#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE_OPTIONS_API_VERSION) \
    }, \
    .endpoint = "https://api.thingspeak.com/", \
    __VA_ARGS__ \
}
/* Input Ports */
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD (0)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_0 (0)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_1 (1)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_2 (2)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_3 (3)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_4 (4)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_5 (5)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_6 (6)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_7 (7)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__FIELD_LAST (7)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN__STATUS (8)
#define SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE__IN_LAST (8)

#ifndef SOL_LOG_DOMAIN
#define SOL_LOG_DOMAIN &_log_domain
#include "sol-log.h"

#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_DECLARE(_var, _name)     SOL_ATTR_UNUSED struct sol_log_domain _var = {         .name = "sol-" _name,         .color = SOL_LOG_COLOR_MAGENTA,         .level = SOL_LOG_LEVEL_WARNING     }

#define SOL_LOG_INTERNAL_DECLARE_STATIC(_var, _name)     static SOL_LOG_INTERNAL_DECLARE(_var, _name)

SOL_LOG_INTERNAL_DECLARE_STATIC(_log_domain, "flow-thingspeak");

#else // #ifdef SOL_LOG_ENABLED

#define SOL_LOG_INTERNAL_DECLARE(_var, _name)
#define SOL_LOG_INTERNAL_DECLARE_STATIC(_var, _name)

#ifdef SOL_LOG_DOMAIN
#undef SOL_LOG_DOMAIN
#define SOL_LOG_DOMAIN NULL
#endif // #ifdef SOL_LOG_DOMAIN

#endif // #ifdef SOL_LOG_ENABLED
#endif // ifndef SOL_LOG_DOMAIN

#ifdef __cplusplus
}
#endif
